<?php
namespace nulib\db\_private;

use nulib\cl;
use nulib\str;
use nulib\ValueException;

abstract class _base extends _common {
  abstract protected static function verifix(&$sql, ?array &$bindings=null, ?array &$meta=null): void;

  static function with($sql, ?array $params=null): array {
    static::verifix($sql, $params);
    return [$sql, $params];
  }

  function __construct($sql, ?array $bindings=null) {
    static::verifix($sql, $bindings, $meta);
    $this->sql = $sql;
    $this->bindings = $bindings;
    $this->meta = $meta;
  }

  /** @var string */
  protected $sql;

  function getSql(): string {
    return $this->sql;
  }

  /** @var ?array */
  protected $bindings;

  function getBindings(): ?array {
    return $this->bindings;
  }

  /** @var ?array */
  protected $meta;

  function isInsert(): bool {
    return ($this->meta["isa"] ?? null) === "insert";
  }
}
